using System;
using System.Collections.Generic;
using System.Text;

namespace DesignPattern
{
    abstract class Processor
    {
        public abstract int Mhz { get; }
    }

    class ConcreteProcessor : Processor
    {
        public override int Mhz
        {
            get { return 1024; }
        }
    }

    abstract class ComputerFactory
    {
        public abstract Processor GetProcessor();
    }

    class ConcreteComputerFactory : ComputerFactory
    {
        ConcreteProcessor concProc = null;

        public override Processor GetProcessor()
        {
            Console.WriteLine("ConcreteComputerFactory GetProcessor ");

            if (null == concProc)
            {
                Console.WriteLine("Creating ConcreteProcessor ...");
                concProc = new ConcreteProcessor();
            }
            return concProc;
        }
    }
}
