using System;
using System.Collections.Generic;
using System.Text;

namespace DesignPattern
{
    class FormInputValues
    {
        Memento memento;
        private string state;

        public string State
        {
            get { return state; }
            set
            {
                state = value;
                Console.WriteLine("State is " + state);
            }
        }

        public Memento SaveMemento()
        {
            memento = new Memento();
            memento.State = state;
            return memento;
        }

        public void RestoreMemento()
        {
            Console.WriteLine("Restoring the state");
            this.State = this.memento.State;
        }
    }

    /// <summary>
    /// Holds data for the input values.
    /// </summary>
    class Memento
    {
        private string state;

        // Property
        public string State
        {
            set { this.state = value; }
            get { return state; }
        }
    }

    // "Caretaker"

    class BackUpFormInputValues
    {
        private Memento memento;

        public Memento Memento
        {
            set { memento = value; }
            get { return memento; }
        }
    }
}
